/*
 * Copyright (c) 1989 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */
/* 
 * Copyright (c) 1998, Qualcomm Incorporated.
 *
 * Revisions :
 *  9/16/98  [py]
 *         - Edited to be independent of pop.
 *  3/23/98  [PY]
 *         - Added the __STDC__ stuff.
 *
 */

#include <config.h>
#include <stdio.h>
#include <sys/types.h>
#ifdef __STDC__
#include <stdlib.h>
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include "popper.h"

/* 
 *  log:    Make a log entry
 */

static char msgbuf[MAXLINELEN];
#ifdef __STDC__
lprintf(void *p, int stat, const char *format,...)
#else
lprintf(va_alist)
va_dcl
#endif
{
    va_list     ap;
#ifndef __STDC__
    void    *   p;
    int         stat;
    char    *   format;
#endif
#ifdef PYRAMID
    char    *   arg1, *arg2, *arg3, *arg4, *arg5, *arg6;
#endif
    char    *   date_time;
    time_t	clock;


    /* Get the information in to msgbuf */
#ifdef __STDC__
    va_start(ap,format);
#else
    va_start(ap);
    p = va_arg(ap,void *);
    stat = va_arg(ap,int);
    format = va_arg(ap,char *);
#endif

#ifdef HAVE_VPRINTF
    vsprintf(msgbuf,format,ap);
#else
# ifdef PYRAMID
    arg1 = va_arg(ap, char *);
    arg2 = va_arg(ap, char *);
    arg3 = va_arg(ap, char *);
    arg4 = va_arg(ap, char *);
    arg5 = va_arg(ap, char *);
    arg6 = va_arg(ap, char *);
    (void)snprintf(msgbuf, MAXLINELEN, format, arg1, arg2, arg3, arg4, arg5, arg6);
# else
    (void)snprintf(msgbuf, MAXLINELEN, format,((int *)ap)[0],((int *)ap)[1],
		    ((int *)ap)[2], ((int *)ap)[3],((int *)ap)[4],((int *)ap)[5]);
# endif
#endif
    va_end(ap);

    /* If the stream is given send send out put to it. other wise to syslog. */
    if (p) {
	clock = time(0);
	date_time = (char *)ctime(&clock);
	date_time[strlen(date_time) - 1] = '\0';
	(void)fprintf(((FILE *)p),"%s [%d] %s\n",date_time, getpid(), msgbuf);
        (void)fprintf(((FILE *)p),"%s \n", date_time);
        (void)fflush(((FILE *)p));
    }
    else {
        syslog (stat,"%s",msgbuf);
    }

    return(stat);
}
